/* AMX Mod script.
*
* (c) Copyright 2002, dJeyL
* This file is provided as is (no warranties).
*
*/

/*

This AMX plugin requires MySQL MetaSmall module.

For this to work, you might create your MySQL admins table with this SQL query :

  CREATE TABLE admins (
    auth varchar(32) NOT NULL default '',
    password varchar(32) NOT NULL default '',
    access varchar(32) NOT NULL default '',
    flags varchar(32) NOT NULL default ''
  ) TYPE=MyISAM;


IMPORTANT:
. check $moddir/addons/amx/mysql.cfg for MySQL access configuration
. you still need admin.amx base plugin
. you still need admin.cfg config file, but you can remove admins ("amx_admin" lines)
. admins left there will still be loaded

*/

#include <amxmod>
#include <mysql>

public admin_sql(){
	new host[64],user[32],pass[32],db[32],error[128]
	get_cvar_string("amx_mysql_host",host,63)
	get_cvar_string("amx_mysql_user",user,31)
	get_cvar_string("amx_mysql_pass",pass,31)
	get_cvar_string("amx_mysql_db",db,31)
	
	new mysql = mysql_connect(host,user,pass,db,error,127)
	if(mysql < 1){
		server_print("MySQL error: can't connect: '%s'",error)
		return PLUGIN_HANDLED	
	}
	
	if(mysql_query(mysql,"SELECT auth,password,access,flags FROM admins") < 1)	{
		mysql_error(mysql,error,127)
		server_print("MySQL error: can't load admins: '%s'",error)
		return PLUGIN_HANDLED
	}
	
	new auth[32], password[32], access[32], flags[32], cnt = 0
	while( mysql_nextrow(mysql) > 0 )	{
		mysql_getfield(mysql,1,auth,31)
		mysql_getfield(mysql,2,password,31)
		mysql_getfield(mysql,3,access,31)
		mysql_getfield(mysql,4,flags,31)
		server_cmd("amx_admin ^"%s^" ^"%s^" ^"%s^" ^"%s^"",auth,password,access,flags)
		++cnt
	}
	
	server_print("[AMX] Loaded %d admin(s) from database",cnt)
	mysql_close(mysql)
	return PLUGIN_HANDLED
}

public plugin_init(){
	register_plugin("Admins from MySQL","0.6","dJeyL")
	register_srvcmd("amx_sqladmins","admin_sql")
	register_cvar("amx_mysql_host","127.0.0.1")
	register_cvar("amx_mysql_user","root")
	register_cvar("amx_mysql_pass","")
	register_cvar("amx_mysql_db","amx")
	server_cmd("exec addons/amx/mysql.cfg;amx_sqladmins")
	return PLUGIN_CONTINUE
}
