/* AMX Mod script.
*
* (c) Copyright 2002, OLO
* This file is provided as is (no warranties).
*
*/

/*  cvar:
*   amx_avlist_mode < flags >
*   "a" - shows attackers
*   "b" - shows victims
*   "c" - shows killer
*   "d" - displays player stats at the end of map
*   "e" - displays top15 at the end of map
*   "f" - displays killer hp&ap to victim console and screen
*
*   client cmds:
*   say /hp - displays information about user killer
*   say /stats - displays players stats and rank
*   say /top15 - displays first 15. players
*   say /rank - displays user position in rank
*   say /statsme - displays user stats
*/

#include <amxmod>
#include <csstats>

new killers[33][4]
new klist[33]
new buffor[1284]
new user_position[33]
new bool:user_state[33]
new user_players[33][32]
new body_part[8][] = {"whole body","head","chest","stomach","left arm","right arm","left leg","right leg"}
new avmode

/* build list of attackers */
get_attackers(id) {
	new temp[64],name[32],wpn[32], stats[8],body[8],found=0
	copy(buffor,1024,"Attackers:^n")
	new amax = get_maxplayers()
	for(new a = 1; a <= amax; ++a){
		if(get_user_astats(id,a,stats,body,wpn,31)){
			found = 1
			if (stats[0])
				format(wpn,31," -- %s",wpn)
			else
				wpn[0] = 0
			get_user_name(a,name,31)
			format(temp,63,"%s -- %d dmg / %d hit(s)%s^n",name,stats[6],stats[5],wpn)
			add(buffor,1024,temp)
		}
	}
	return found
}

/* build list of victims */
get_victims(id) {
	new temp[64],name[32],wpn[32], stats[8],body[8],found=0
	copy(buffor,1024,"Victims:^n")
	new amax = get_maxplayers()
	for(new a = 1; a <= amax; ++a){
		if(get_user_vstats(id,a,stats,body,wpn,31)){
			found = 1
			if (stats[1])
				format(wpn,31," -- %s",wpn)
			else
				wpn[0] = 0
			get_user_name(a,name,31)
			format(temp,63,"%s -- %d dmg / %d hit(s)%s^n",name,stats[6],stats[5],wpn)
			add(buffor,1024,temp)
		}
	}
	return found
}

/* build list of hita for AV List */
get_hits(id,killer) {
	new temp[64], stats[8], body[8]
	buffor[0] = 0
	get_user_astats(id,killer,stats,body)
	for(new a = 1; a < 8; ++a){
		if(body[a]){
			format(temp,63,"%s: %d^n",body_part[a],body[a])
			add(buffor,1024,temp)
		}
	}
}

/*get top 15 */
get_top15(){
	new temp[128], stats[8], body[8], name[33]
	copy(buffor,1280,"#   nick                           kills/deaths          hits/shots/headshots^n")
	new imax = get_statsnum()
	if (imax > 15) imax = 15
	for(new a = 0; a < imax; ++a){
		get_stats(a,stats,body,name,32)
		format(temp,127,"%2d.  %-28.27s    %d/%d                      %d/%d/%d^n",a+1,name,stats[0],stats[1],stats[5],stats[4],stats[2])
		add(buffor,1280,temp)
	}
}

/* build list of hits for say hp */
get_myhits(id,killed) {
	new temp[64], stats[8], body[8], found = 0
	get_user_name(killed,temp,32)
	format(buffor,1024,"* You hit %s in:",temp)
	get_user_vstats(id,killed,stats,body)
	for(new a = 1; a < 8; ++a){
		if(body[a]){
			found = 1
			format(temp,63," %s: %d ",body_part[a],body[a])
			add(buffor,1024,temp)
		}
	}
	return found
}

/* amx_avlist_mode */
get_avmode() {
		new myavmode[9]
		get_cvar_string("amx_avlist_mode",myavmode,8)
		return read_flags(myavmode)
}

/* save hits and damage */
public damage_event(id) {
	if (killers[id][0]) {
		klist[id] = 0
		if (avmode&4){
			new name[32], stats[8], body[8], wpn[33], mstats[8], mbody[8]
			get_user_name(killers[id][0],name,31)
			get_user_astats(id,killers[id][0],stats,body,wpn,31)
			get_user_vstats(id,killers[id][0],mstats,mbody)
			set_hudmessage(220,80,0,0.05,0.15,0, 6.0, 12.0, 1.0, 2.0, 1)
			get_hits(id,killers[id][0])
			show_hudmessage(id,"%s killed you with %s^nfrom distance of %.2f meters.^nHe did %d damage to you with %d hit(s)^nand still has %dhp and %dap.^nYou did %d damage to him with %d hit(s).^nHe hits you in:^n%s",
					name,wpn,float(killers[id][3]) * 0.0254,	stats[6],stats[5],		killers[id][1],killers[id][2],
						mstats[6],mstats[5],buffor )
		}
		if ((avmode&2)&&get_victims(id)){
			set_hudmessage(0,80,220,0.55,0.60,0, 6.0, 12.0, 1.0, 2.0, 4)
			show_hudmessage(id,buffor)
		}
		if ((avmode&1)&&get_attackers(id)){
			set_hudmessage(220,80,0,0.55,0.35,0, 6.0, 12.0, 1.0, 2.0, 3)
			show_hudmessage(id,buffor)
		}
	}
}

/* save state at death */
public deathmsg_event() {
	new killer = read_data(1)
	new victim = read_data(2)
	if (killer != victim && killer)	{
		new vorigin[3], korigin[3]
		get_user_origin(victim,vorigin)
		get_user_origin(killer,korigin)
		killers[victim][0] = killer
		killers[victim][1] = get_user_health(killer)
		killers[victim][2] = get_user_armor(killer)
		killers[victim][3] = get_distance(vorigin,korigin)
		avmode = get_avmode()
		if (avmode&32){
			new name[32], kmsg[128]
			get_user_name(killer,name,31)
			format(kmsg,127,"%s still has %dhp and %dap",name,killers[victim][1],killers[victim][2])
			client_print(victim,print_console,kmsg)
			set_hudmessage(255,255,255,0.02,0.9,2, 1.5, 3.0, 0.02, 5.0, 1)
			show_hudmessage(victim,kmsg)
		}
	}
}

public resethud_event(id) {
	if(klist[id]){
		avmode = get_avmode()
		if ((avmode&2)&&get_victims(id)){
			set_hudmessage(0,80,220,0.55,0.60,0, 6.0, 12.0, 1.0, 2.0, 4)
			show_hudmessage(id,buffor)
		}
		if ((avmode&1)&&get_attackers(id)){
			set_hudmessage(220,80,0,0.55,0.35,0, 6.0, 12.0, 1.0, 2.0, 3)
			show_hudmessage(id,buffor)
		}
	}
	killers[id][0] = 0
	klist[id] = 1
}

public display_killer(id) {
	if (killers[id][0]) {
		new name[32], stats[8], body[8], wpn[33], mstats[8], mbody[8]
		get_user_name(killers[id][0],name,31)
		get_user_astats(id,killers[id][0],stats,body,wpn,31)
		get_user_vstats(id,killers[id][0],mstats,mbody)
		client_print(id,print_chat,"* %s killed you with %s from distance of %.2f meters",	name,wpn,float(killers[id][3]) * 0.0254 )
		client_print(id,print_chat,"* He did %d damage to you with %d hit(s) and still had %dhp and %dap",
			stats[6],stats[5], killers[id][1],killers[id][2] )
		client_print(id,print_chat,"* You did %d damage to him with %d hit(s)",mstats[6],	mstats[5] )
		if (get_myhits(id,killers[id][0])) client_print(id,print_chat,buffor)
	}
	else {
		client_print(id,print_chat,"* You have no killer...")
	}
	return PLUGIN_CONTINUE
}

public disp_stats(id)
	display_stats(id,id)

public display_stats(id,dest) {
		new name[32], stats[8], body[8], temp[256]
		get_user_wstats(id,0,stats,body)
		format(buffor,255,"Kills: %d^nDeaths: %d^nDamage: %d^nHits: %d^nShots: %d^n^n",
			stats[0],stats[1],stats[6],stats[5],stats[4])
		for(new a = 1; a < 31; ++a)	{
			if (get_user_wstats(id,a,stats,body)){
				get_weaponname(a,name,31)
				format(temp,255,"%s shots: %d  hits: %d  damage: %d  kills: %d  deaths: %d^n",
					name[7],stats[4],stats[5],stats[6],stats[0],stats[1])
				add(buffor,1024,temp)
			}
		}
		get_user_name(id,name,31)
		show_motd(dest,buffor,name)
		return PLUGIN_CONTINUE
}

public disp_rank(id)
	display_rank(id,id)

public display_rank(id,dest) {
		new name[32], stats[8], body[8]
		new rank_pos = get_user_stats(id,stats,body)
		new len = format(buffor,1283,"Kills: %d^nDeaths: %d^nDamage: %d^nHits: %d^nShots: %d^n^n",
			stats[0],stats[1],stats[6],stats[5],stats[4])
		len += format(buffor[len],1283,"Hits:^n%s: %d^n%s: %d^n%s: %d^n%s: %d^n%s: %d^n%s: %d^n%s: %d^n^n",
			body_part[1],body[1],body_part[2],body[2],body_part[3],body[3],	body_part[4],body[4],
			body_part[5],body[5],body_part[6],body[6],body_part[7],body[7])
		format(buffor[len],1283,"%s rank is %d of %d",(id==dest)?"Your":"His", rank_pos,get_statsnum())
		get_user_name(id,name,31)
		show_motd(dest,buffor,name)
		return PLUGIN_CONTINUE
}

public display_top15(id) {
	get_top15()
	show_motd(id,buffor,"Top 15")
	return PLUGIN_CONTINUE
}

public end_game_stats(){
	avmode = get_avmode()
	if (avmode&8){
		new players[32], inum
		get_players(players,inum)
		for(new i = 0; i < inum; ++i)
			display_stats(players[i],players[i])
	}	
	else if (avmode&16)	{
		new players[32], inum
		get_players(players,inum)
		get_top15()
		for(new i = 0; i < inum; ++i)
			show_motd(players[i],buffor,"Top 15")
	}
}

public intermission_event()
	set_task(1.0,"end_game_stats")
	
public disp_pplstats(id)
	show_ppl_menu(id,user_position[id]=0)

public action_ppl_menu(id,key){
	switch(key){
	case 7: {
		user_state[id] = !user_state[id]
		show_ppl_menu(id,user_position[id])
	}
	case 8: show_ppl_menu(id,++user_position[id])
	case 9:	show_ppl_menu(id,--user_position[id])
	default:{
		new option = user_position[id] * 7 + key
		new index = user_players[id][option]
		if (is_user_connected(index)){
			if (user_state[id])
				display_rank(index,id)
			else
				display_stats(index,id)
		}
		show_ppl_menu(id,user_position[id])
		}
	}
	return PLUGIN_HANDLED
}

show_ppl_menu(id,pos){
	if (pos < 0) return PLUGIN_HANDLED
	new menu_body[512], inum, start = pos * 7
	get_players(user_players[id],inum)
	if (start >= inum) start = pos = user_position[id] = 0
	new len = format(menu_body,511,"\yAMX Stats\R%d/%d^n\w^n",pos + 1,((inum/7)+((inum%7)?1:0)))
	new name[32], end = start + 7, keys = (1<<9)|(1<<7)
	if (end > inum) end = inum
	pos = 0
	for(new a = start; a < end; ++a){
		get_user_name(user_players[id][a],name,31)
		keys |= (1<<pos)
		len += format(menu_body[len],511,"%d. %s^n\w",++pos,name)
	}
	len += format(menu_body[len],511,"^n8. %s^n\w",user_state[id] ? "Show rank" : "Show stats" )
	if (end != inum){
		len += format(menu_body[len],511,"^n9. More...^n0. Back")
		keys |= (1<<8)
	}
	else {
		len += format(menu_body[len],511,"^n0. Back")
	}
	show_menu(id,keys,menu_body)
	return PLUGIN_HANDLED
}

public plugin_init() {
	register_plugin("Small Stats","0.9.2","default")
	register_event("Damage","damage_event","b","2!0","3=0","4!0")
	register_event("DeathMsg","deathmsg_event","a")
	register_event("ResetHUD","resethud_event","be")
	register_event("30","intermission_event","a")
	register_cvar("amx_avlist_mode","abce")
	register_clcmd("say /hp","display_killer",0,"- displays info. about your killer")
	register_clcmd("say /statsme","disp_stats",0,"- displays your stats")
	register_clcmd("say /stats","disp_pplstats",0,"- displays others stats")	
	register_clcmd("say /top15","display_top15",0,"- displays top 15 players")
	register_clcmd("say /rank","disp_rank",0,"- displays your server stats")
	register_menucmd(register_menuid("\yAMX Stats"),1023,"action_ppl_menu")
	return PLUGIN_CONTINUE
}
